stages:
  - lint
  - test
  - deploy

shellcheck:
  stage: lint
  image: koalaman/shellcheck-alpine:stable
  before_script:
    - shellcheck --version
  script:
    - shellcheck --exclude=SC2034,SC2148 *.sh
  only:
    changes:
      - "*.sh"

markdown lint:
  stage: lint
  image: pipelinecomponents/markdownlint:latest
  script:
    - mdl --style all --warnings .
  only:
    changes:
      - "**/*.md"
  allow_failure: true

doc-test:
  stage: test
  image: python:3.8-buster
  before_script:
    - pip install mkdocs
  script:
    - mkdocs build --strict --verbose --site-dir test
  artifacts:
    paths:
      - test
  rules:
    - if: $CI_COMMIT_REF_NAME != $CI_DEFAULT_BRANCH

pages:
  stage: deploy
  image: python:3.8-buster
  before_script:
    - pip install mkdocs
  script:
    - mkdocs build --strict --verbose --site-dir public
  artifacts:
    paths:
      - public
  rules:
    - if: $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH
